ON *:LOAD: {
  set %qnldialog.hideall 0
  set %qnldialog.hidedone 0
  set %qnldialog.disable 0
  set %qnldialog.strip 1
  set %qnldialog.messages 1
  set %qnldialog.commands 0
  ql
}

ON *:UNLOAD: {
  echo -m Unloaded Q & L Dialog. Removing variables...
  unset %qnldialog.*
  echo -m Done!
}
alias ql {
  dialog -m qnldialog qnldialog
  if ($1 != $null) {
    did -i qnldialog 4 0 $1
    qnldialog.helplist
  }
}
dialog qnldialog {
  title "Q & L Control"
  size -1 -1 249 86
  option dbu

  edit "", 5, 0 0 205 75, read multi autovs hsbar vsbar

  menu "Options", 9
  menu "Show messages in", 23, 9
  item "status window", 14, 23
  item "open window", 15, 23
  item "the dialog", 16, 23
  item "Disable Q n L Dialog", 10, 9
  item "Hide ''Done.'' messages", 11, 9
  item "Hide all Q and L messages", 12, 9
  item "Strip codes from messages", 13, 9
  item "Hide bot tools", 21, 9
  menu "Auth", 25
  item "Auth now!", 26, 25
  item "Settings", 27, 25
  menu "Help", 17
  item "Homepage", 20, 17
  item "Read Me", 18, 17 
  item "About", 19, 17

  combo 4, 220 0 28 40, edit drop
  list 3, 206 21 43 54, size vsbar
  text "Bot:", 6, 209 2 11 9
  text "Commands:", 7, 209 13 32 7
  edit "", 22, 0 76 205 10, autohs
  button "Send", 24, 206 76 42 9, ok

  text "Name:", 28, 14 22 16 10
  edit "", 29, 30 21 66 10, autohs
  text "Pass:", 30, 14 35 16 10
  edit "", 31, 30 33 66 10, autohs pass
  box "Authing", 32, 9 11 91 60
  check "Auth on connect:", 33, 14 51 80 9, left
  box "Attempt to regain...", 34, 120 11 80 35
  check "...voice(+v) status:", 35, 124 21 70 9, left
  check "Encoded password:", 36, 14 43 80 9, left
  check "...operator(+o) status:", 37, 124 30 70 9, left
  check "Enable auth control:", 38, 80 1 60 10, left
  button "Done", 39, 120 59 36 12
  button "Cancel", 40, 165 59 36 12
  check "Hide hostmask(+x):", 41, 14 59 80 9, left
}

ON *:DIALOG:qnldialog:init:0: {
  did -bh qnldialog 28-41
  did -o qnldialog 29 1 %qnldialog.auth.user
  did -o qnldialog 31 1 $iif(%qnldialog.auth.encode == 1, $decode(%qnldialog.auth.pass), %qnldialog.auth.pass)
  did -f qnldialog 22
  set %qnldialog.line 1
  did -i qnldialog 4 1 Q
  did -i qnldialog 4 2 L
  if (%qnldialog.disable == 1) { did -c qnldialog 10 }
  if (%qnldialog.hidedone == 1) { did -c qnldialog 11 }
  if (%qnldialog.hideall == 1) { did -c qnldialog 12 }
  if (%qnldialog.strip == 1) { did -c qnldialog 13 }
  if (%qnldialog.messages == 1) { did -c qnldialog 16 }
  if (%qnldialog.messages == 2) { did -c qnldialog 15 }
  if (%qnldialog.messages == 3) { did -c qnldialog 14 }
  if (%qnldialog.commands == 1) {
    did -c qnldialog 21
    did -bh qnldialog 4,3,6,7,22,24
    dialog -s qnldialog -1 -1 410 169
  }
  if (%qnldialog.auth.autoa == 1) { did -c qnldialog 33 }
  if (%qnldialog.auth.autov == 1) { did -c qnldialog 35 }
  if (%qnldialog.auth.encode == 1) { did -c qnldialog 36 }
  if (%qnldialog.auth.autoo == 1) { did -c qnldialog 37 }
  if (%qnldialog.auth.enable == 1) { did -c qnldialog 38 }
  if (%qnldialog.auth.xmode == 1) { did -c qnldialog 41 }

}
alias qnldialog.helplist {
  did -r qnldialog 3 
  var %qnldialog.helplist.line 1
  var %qnldialog.helplist.error 0
  while (%qnldialog.helplist.error == 0) {
    if ($readini($scriptdirQnL.ini,$did(qnldialog,4),%qnldialog.helplist.line)) {
      did -i qnldialog 3 %qnldialog.helplist.line $readini($scriptdirQnL.ini,$did(qnldialog,4),%qnldialog.helplist.line)
      inc %qnldialog.helplist.line 1
    }
    else {
      var %qnldialog.helplist.error 1
    }
  }
}


ON *:DIALOG:qnldialog:sclick:4: {
  qnldialog.helplist
}
ON *:DIALOG:qnldialog:sclick:24: {
  if ($dialog(qnldialog).focus == 22 || 24) {
    if (!$did(qnldialog,22)) {
      halt
    }
    elseif (!$did(qnldialog,4).sel) {
      did -i qnldialog 5 %qnldialog.line You must set a bot!
      inc %qnldialog.line 1
      did -r qnldialog 22
      halt
    }
    else {
      .msg $did(qnldialog,4) $did(qnldialog,22)
      did -i qnldialog 5 %qnldialog.line $time($timestampfmt) --> $did(qnldialog,4) $+ : $did(qnldialog,22)
      inc %qnldialog.line 1
      did -r qnldialog 22
    }
  }
  halt
}
ON *:DIALOG:qnldialog:menu:10: {
  if ($did(qnldialog,10).state == 0) {
    set %qnldialog.disable 1
    did -c qnldialog 10
  }
  else {
    set %qnldialog.disable 0
    did -u qnldialog 10
  }
}
ON *:DIALOG:qnldialog:menu:11: {
  if ($did(qnldialog,11).state == 0) {
    set %qnldialog.hidedone 1
    did -c qnldialog 11
  }
  else {
    set %qnldialog.hidedone 0
    did -u qnldialog 11
  }
}
ON *:DIALOG:qnldialog:menu:12: {
  if ($did(qnldialog,12).state == 0) {
    set %qnldialog.hideall 1
    did -c qnldialog 12
  }
  else {
    set %qnldialog.hideall 0
    did -u qnldialog 12
  }
}
ON *:DIALOG:qnldialog:menu:13: {
  if ($did(qnldialog,13).state == 0) {
    set %qnldialog.strip 1
    did -c qnldialog 13
  }
  else {
    set %qnldialog.strip 0
    did -u qnldialog 13
  }
}
ON *:DIALOG:qnldialog:menu:16: {
  set %qnldialog.messages 1
  did -c qnldialog 16
  did -u qnldialog 15
  did -u qnldialog 14
}
ON *:DIALOG:qnldialog:menu:15: {
  set %qnldialog.messages 2
  did -u qnldialog 16
  did -c qnldialog 15
  did -u qnldialog 14
}
ON *:DIALOG:qnldialog:menu:14: {
  set %qnldialog.messages 3
  did -u qnldialog 16
  did -u qnldialog 15
  did -c qnldialog 14
}
ON *:DIALOG:qnldialog:menu:20: {
  url -n http://www.rockeyrex.org
}
ON *:DIALOG:qnldialog:menu:26: {
  if (%qnldialog.auth.user && %qnldialog.auth.pass) {
    qnldialog.auth.now
  }
}
ON *:DIALOG:qnldialog:menu:19: {
  did -i qnldialog 5 %qnldialog.line Q n L Dialog made by Sebastian ''RockeyRex'' Mntymki
  inc %qnldialog.line 1
  did -i qnldialog 5 %qnldialog.line Version: 1.2
  inc %qnldialog.line 1
}
ON *:DIALOG:qnldialog:menu:18: {
  if (!$exists($scriptdir $+ qnldialog-readme.txt)) {
    write $scriptdir $+ qnldialog-readme.txt
    did -i qnldialog 5 %qnldialog.line ReadMe file not found. Creating a blank file.
    inc %qnldialog.line 1
  }
  run $scriptdir $+ qnldialog-readme.txt
}
ON *:DIALOG:qnldialog:menu:21: {
  if ($did(qnldialog,21).state == 0) {
    did -bh qnldialog 4,3,6,7,22,24
    dialog -s qnldialog -1 -1 410 169
    did -c qnldialog 21
    set %qnldialog.commands 1
  }
  else {
    did -ev qnldialog 4,3,6,7,22,24
    dialog -s qnldialog -1 -1 498 191
    did -u qnldialog 21
    set %qnldialog.commands 0
    did -f qnldialog 22
  }
}
ON *:DIALOG:qnldialog:menu:27: {
  did -bh qnldialog 4,5,3,6,7,22,24
  dialog -s qnldialog -1 -1 410 169
  did -ev qnldialog 28-41
  if (%qnldialog.auth.enable != 1) {
    did -b qnldialog 28-37
  }
}
ON *:DIALOG:qnldialog:DCLICK:3: {
  if ($server != $null) {
    if ($did(qnldialog,4) != $null) {
      .msg $did(qnldialog,4) help $did(qnldialog,3,$did(qnldialog,3).sel).text
    }
    else {
      did -i qnldialog 5 %qnldialog.line Define a bot!
      inc %qnldialog.line 1
    }
  }
  else {
    did -i qnldialog 5 %qnldialog.line You are not connected to a server.
    inc %qnldialog.line 1
  }
}
ON ^*:NOTICE:*:*: {
  if (%qnldialog.disable == 0) {
    if ($nick == Q || $nick == L) {
      if (%qnldialog.hideall == 0) {
        if (%qnldialog.hidedone == 1 && $1 == Done.) {
          halt
        }
        if (%qnldialog.messages == 1) {
          if (!$dialog(qnldialog)) {
            ql $nick
          }
          if (%qnldialog.strip == 1) {
            did -i qnldialog 5 %qnldialog.line $time($timestampfmt) * $nick $+ : $strip($1-,burc)
          }
          else {
            did -i qnldialog 5 %qnldialog.line $time($timestampfmt) * $nick $+ : $1-
          }
          inc %qnldialog.line 1
        }
        if (%qnldialog.messages == 2) {
          if (%qnldialog.strip == 1) {
            echo -m $active $time($timestampfmt) * $nick $+ :  $strip($1-,burc)
          }
          else {
            echo -m $active $time($timestampfmt) * $nick $+ :  $1-
          }        
        }
        if (%qnldialog.messages == 3) {
          if (%qnldialog.strip == 1) {
            echo -ms $time($timestampfmt) * $nick $+ :  $strip($1-,burc)
          }
          else {
            echo -ms $time($timestampfmt) * $nick $+ :  $1-
          }        
        }
      }
      haltdef
    }
  }
}


; Authing stuff after this.

ON *:DIALOG:qnldialog:sclick:38: {
  if ($did(qnldialog,38).state == 1) { did -e qnldialog 28-37 }
  else { did -b qnldialog 28-37 }
}
ON *:DIALOG:qnldialog:sclick:39: {
  if ($did(qnldialog,38).state == 1) {
    set %qnldialog.auth.encode $did(qnldialog,36).state
    set %qnldialog.auth.user $did(qnldialog,29)
    set %qnldialog.auth.pass $iif(%qnldialog.auth.encode == 1, $encode($did(qnldialog,31)), $did(qnldialog,31))
    set %qnldialog.auth.autoa $did(qnldialog,33).state
    set %qnldialog.auth.autov $did(qnldialog,35).state
    set %qnldialog.auth.autoo $did(qnldialog,37).state
    set %qnldialog.auth.xmode $did(qnldialog,41).state
  }
  set %qnldialog.auth.enable $did(qnldialog,38).state
  did -bh qnldialog 28-41
  did -ev qnldialog 5
  if (%qnldialog.commands != 1) {
    did -ev qnldialog 4,3,6,7,22,24
    dialog -s qnldialog -1 -1 498 191
  }
  did -i qnldialog 5 %qnldialog.line Auth settings saved.
  inc %qnldialog.line 1
}
ON *:DIALOG:qnldialog:sclick:40: {
  did -o qnldialog 29 1 %qnldialog.auth.user
  did -o qnldialog 31 1 $iif(%qnldialog.auth.encode == 1, $decode(%qnldialog.auth.pass), %qnldialog.auth.pass)
  if (%qnldialog.auth.autoa == 1) { did -c qnldialog 33 }
  else { did -u qnldialog 33 }
  if (%qnldialog.auth.autov == 1) { did -c qnldialog 35 }
  else { did -u qnldialog 35 }
  if (%qnldialog.auth.encode == 1) { did -c qnldialog 36 }
  else { did -u qnldialog 36 }
  if (%qnldialog.auth.autoo == 1) { did -c qnldialog 37 }
  else { did -u qnldialog 37 }
  if (%qnldialog.auth.enable == 1) { did -c qnldialog 38 }
  else { did -u qnldialog 38 }
  if (%qnldialog.auth.xmode == 1) { did -c qnldialog 41 }
  else { did -u qnldialog 41 }

  did -bh qnldialog 28-41
  did -ev qnldialog 5
  if (%qnldialog.commands != 1) {
    did -ev qnldialog 4,3,6,7,22,24
    dialog -s qnldialog -1 -1 498 191
  }
}
ON *:CONNECT: {
  if (($network == QuakeNet) && (%qnldialog.auth.autoa == 1)) {
    qnldialog.auth.now
  }
}
alias qnldialog.auth.now {
  .msg Q@CServe.quakenet.org auth %qnldialog.auth.user $iif(%qnldialog.auth.encode == 1, $decode(%qnldialog.auth.pass), %qnldialog.auth.pass)
  if (%qnldialog.auth.xmode == 1) {
    mode $me +x
  }
}
ON *:DEOP:#: {
  if (($nick != $me) && ($network == QuakeNet) && (%qnldialog.auth.autoo == 1)) {
    if ($opnick == $me) {
      if (Q ison $chan) {    
        .msg Q op $chan $me
      }
      if (L ison $chan) {
        .msg L op $chan $me
      }
    }
  }
}
ON *:DEVOICE:#: {
  if (($nick != $me) && ($network == QuakeNet) && (%qnldialog.auth.autov == 1)) {
    if ($vnick == $me) {
      if (Q ison $chan) {    
        .msg Q voice $chan $me
      }
      if (L ison $chan) {
        .msg L voice $chan $me
      }
    }
  }
}
